searchData={"content_type":"text/markdown","items":[{"doc":"Documentation for `Seeker`.","ref":"Seeker.html","title":"Seeker","type":"module"},{"doc":"Query implementation for `Seeker`.","ref":"Seeker.Query.html","title":"Seeker.Query","type":"module"},{"doc":"","ref":"Seeker.Query.html#call/2","title":"Seeker.Query.call/2","type":"function"},{"doc":"Query predicates implementation for `Seeker`.","ref":"Seeker.Query.Predicates.html","title":"Seeker.Query.Predicates","type":"module"},{"doc":"","ref":"Seeker.Query.Predicates.html#call/3","title":"Seeker.Query.Predicates.call/3","type":"function"},{"doc":"Search implementation for `Seeker`.","ref":"Seeker.Search.html","title":"Seeker.Search","type":"module"},{"doc":"","ref":"Seeker.Search.html#call/2","title":"Seeker.Search.call/2","type":"function"},{"doc":"Sort implementation for `Seeker`.","ref":"Seeker.Sort.html","title":"Seeker.Sort","type":"module"},{"doc":"","ref":"Seeker.Sort.html#call/2","title":"Seeker.Sort.call/2","type":"function"},{"doc":"","ref":"Seeker.PredicateNotFoundError.html","title":"Seeker.PredicateNotFoundError","type":"exception"},{"doc":"","ref":"Seeker.PredicateNotFoundError.html#message/1","title":"Seeker.PredicateNotFoundError.message/1","type":"function"},{"doc":"# Changelog\n\nAll notable changes to this project will be documented in this file.\n\nThe format is based on [Keep a Changelog](https://keepachangelog.com/en/1.0.0/),\nand this project adheres to [Semantic Versioning](https://semver.org/spec/v2.0.0.html).","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"* Initial version of Seeker library","ref":"changelog.html#v0-1-0","title":"v0.1.0 - Changelog","type":"extras"},{"doc":"# Contributing to Seeker","ref":"contributing.html","title":"Contributing to Seeker","type":"extras"},{"doc":"1. Fork seeker\n2. Create a topic branch\n3. Make logically-grouped commits with clear commit messages\n4. Push commits to your fork\n5. Open a pull request against seeker/main","ref":"contributing.html#pull-requests-welcome","title":"Pull Requests Welcome - Contributing to Seeker","type":"extras"},{"doc":"If you believe there to be a bug, please provide the maintainers with enough\ndetail to reproduce or a link to an app exhibiting unexpected behavior. For\nhelp, please start with Stack Overflow.","ref":"contributing.html#issues","title":"Issues - Contributing to Seeker","type":"extras"},{"doc":"# Seeker\n\nThis library will help you easily add searching to your Phoenix/Ecto\napplication, without any additional dependencies.\n\nThere are advanced searching solutions around, like ElasticSearch or Algolia.\nSeeker will do the job for many Phoenix/Ecto apps, without the need to run\nadditional infrastructure or work in a different language.","ref":"readme.html","title":"Seeker","type":"extras"},{"doc":"Add `seeker` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:seeker, \"~> 0.1.0\"}\n  ]\nend\n```","ref":"readme.html#installation","title":"Installation - Seeker","type":"extras"},{"doc":"Add a `MyApp.Seeker` module as the following example:\n\n```elixir\n# lib/my_app/seeker.ex\n\ndefmodule MyApp.Seeker do\n  use Seeker,\n    otp_app: :my_app,\n    repo: MyApp.Repo\nend\n```\n\nAssuming a params map with the following structure:\n\n```elixir\n%{\n  q: %{\n    first_name_eq: \"Foo\",\n    email_end: \"gmail.com\",\n    status_in: [\"premium\", \"plus\"]\n  },\n  s: \"last_name+asc\"\n}\n```\n\nPlease check [supported predicates](https://github.com/amco/seeker-ex/blob/main/lib/seeker/query.ex#L8).\n\nThen, use `all/2` function in the controller like this:\n\n```elixir\ndefmodule MyAppWeb.UserController do\n  use MyAppWeb, :controller\n\n  alias MyApp.Seeker\n  alias MyApp.Accounts.User\n\n  def index(conn, params) do\n    users = User |> Seeker.all(params)\n    render(conn, :index, users: users)\n  end\nend\n```\n\nUse `query/2` function when performing queries after using `Seeker` or\nusing pagination. Like this:\n\n```elixir\ndefmodule MyAppWeb.UserController do\n  use MyAppWeb, :controller\n\n  alias MyApp.Accounts.User\n  alias MyApp.{Seeker, Repo}\n\n  def index(conn, params) do\n    page =\n      User\n      |> Seeker.query(params)\n      |> Repo.paginate(params)\n\n    render(conn, :index, page: page)\n  end\nend\n```\n\nDocumentation can be generated with [ExDoc](https://github.com/elixir-lang/ex_doc)\nand published on [HexDocs](https://hexdocs.pm). Once published, the docs can\nbe found at  .","ref":"readme.html#usage","title":"Usage - Seeker","type":"extras"}]}